diff --git a/src/libstrongswan/utils/identification.c b/src/libstrongswan/utils/identification.c
index 6ddaf6c3e..3f9c27d93 100644
--- a/src/libstrongswan/utils/identification.c
+++ b/src/libstrongswan/utils/identification.c
@@ -17,6 +17,28 @@
  * for more details.
  */
 
+/*
+ * Copyright (C) 2019-2022 Marvell 
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a copy
+ * of this software and associated documentation files (the "Software"), to deal
+ * in the Software without restriction, including without limitation the rights
+ * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the Software is
+ * furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+ * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+ * THE SOFTWARE.
+ */
+
 #include <string.h>
 #include <stdio.h>
 #include <errno.h>
@@ -37,7 +59,7 @@ ENUM_NEXT(id_match_names, ID_MATCH_PERFECT, ID_MATCH_PERFECT, ID_MATCH_MAX_WILDC
 	"MATCH_PERFECT");
 ENUM_END(id_match_names, ID_MATCH_PERFECT);
 
-ENUM_BEGIN(id_type_names, ID_ANY, ID_KEY_ID,
+ENUM_BEGIN(id_type_names, ID_ANY, ID_KEY_Q_NAME,
 	"ID_ANY",
 	"ID_IPV4_ADDR",
 	"ID_FQDN",
@@ -49,8 +71,9 @@ ENUM_BEGIN(id_type_names, ID_ANY, ID_KEY_ID,
 	"ID_IPV6_ADDR_RANGE",
 	"ID_DER_ASN1_DN",
 	"ID_DER_ASN1_GN",
-	"ID_KEY_ID");
-ENUM_NEXT(id_type_names, ID_DER_ASN1_GN_URI, ID_DER_ASN1_GN_URI, ID_KEY_ID,
+	"ID_KEY_ID",
+	"ID_KEY_Q_NAME");
+ENUM_NEXT(id_type_names, ID_DER_ASN1_GN_URI, ID_DER_ASN1_GN_URI, ID_KEY_Q_NAME,
 	"ID_DER_ASN1_GN_URI");
 ENUM_END(id_type_names, ID_DER_ASN1_GN_URI);
 
@@ -1306,6 +1329,10 @@ int identification_printf_hook(printf_hook_data_t *data,
 		case ID_DER_ASN1_GN:
 			snprintf(buf, BUF_LEN, "(ASN.1 general name)");
 			break;
+		case ID_KEY_Q_NAME:
+			snprintf(buf, sizeof(buf), "%.*s", (int)this->encoded.len,
+					this->encoded.ptr);
+			break;
 		case ID_KEY_ID:
 			if (chunk_printable(this->encoded, NULL, '?') &&
 				this->encoded.len != HASH_SIZE_SHA1)
@@ -1378,6 +1405,7 @@ static private_identification_t *identification_create(id_type_t type)
 			break;
 		case ID_FQDN:
 		case ID_RFC822_ADDR:
+		case ID_KEY_Q_NAME:
 			this->public.hash = _hash_binary;
 			this->public.equals = _equals_strcasecmp;
 			this->public.matches = _matches_string;
@@ -1441,6 +1469,7 @@ static private_identification_t* create_from_string_with_prefix_type(char *str)
 		{ "asn1gn:",		ID_DER_ASN1_GN			},
 		{ "xmppaddr:",		ID_DER_ASN1_GN          },
 		{ "keyid:",			ID_KEY_ID				},
+		{ "0x",				ID_KEY_Q_NAME			},
 	};
 	private_identification_t *this;
 	int i;
diff --git a/src/libstrongswan/utils/identification.h b/src/libstrongswan/utils/identification.h
index a85b7c538..ffdc08416 100644
--- a/src/libstrongswan/utils/identification.h
+++ b/src/libstrongswan/utils/identification.h
@@ -16,6 +16,28 @@
  * for more details.
  */
 
+/*
+ * Copyright (C) 2019-2022 Marvell 
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a copy
+ * of this software and associated documentation files (the "Software"), to deal
+ * in the Software without restriction, including without limitation the rights
+ * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the Software is
+ * furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+ * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+ * THE SOFTWARE.
+ */
+
 /**
  * @defgroup identification identification
  * @{ @ingroup utils
@@ -126,6 +148,12 @@ enum id_type_t {
 	 */
 	ID_KEY_ID = 11,
 
+	/**
+	 * ID data is a qualifier name string.
+	 * The string MUST NOT contain any terminators.
+	 */
+	ID_KEY_Q_NAME = 12,
+
 	/**
 	 * Private ID type which represents a GeneralName of type URI
 	 */
diff --git a/src/libstrongswan/utils/parser_helper.c b/src/libstrongswan/utils/parser_helper.c
index 69800a781..f77a4fb56 100644
--- a/src/libstrongswan/utils/parser_helper.c
+++ b/src/libstrongswan/utils/parser_helper.c
@@ -14,6 +14,28 @@
  * for more details.
  */
 
+/*
+ * Copyright (C) 2019-2022 Marvell 
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a copy
+ * of this software and associated documentation files (the "Software"), to deal
+ * in the Software without restriction, including without limitation the rights
+ * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the Software is
+ * furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+ * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+ * THE SOFTWARE.
+ */
+
 #include <limits.h>
 #include <ctype.h>
 #include <stdarg.h>
@@ -24,6 +46,9 @@
 
 #include <collections/array.h>
 
+#include <stdlib.h>
+#include <unistd.h>
+
 typedef struct private_parser_helper_t private_parser_helper_t;
 typedef struct parser_helper_file_t parser_helper_file_t;
 
@@ -92,6 +117,42 @@ static parser_helper_file_t *current_file(private_parser_helper_t *this)
 	return NULL;
 }
 
+#ifdef _WIN32
+static bool get_install_dir(char *install_dir)
+{
+	char path[PATH_MAX], *pos;
+	HMODULE module;
+
+	module = GetModuleHandle(NULL);
+	if (!module)
+	{
+		return FALSE;
+	}
+	if (!GetModuleFileName(module, path, sizeof(path)))
+	{
+		return FALSE;
+	}
+	pos = strrchr(path, '\\');
+	if (!pos)
+	{
+		return FALSE;
+	}
+	*pos = 0;
+
+	pos = strstr(path, "\\usr\\");
+	if (!pos)
+	{
+		return FALSE;
+	}
+	*pos = 0;
+
+	memset(install_dir, 0, sizeof(install_dir));
+	strcpy(install_dir, path);
+
+	return TRUE;
+}
+#endif
+
 METHOD(parser_helper_t, file_next, FILE*,
 	private_parser_helper_t *this)
 {
@@ -111,18 +172,48 @@ METHOD(parser_helper_t, file_next, FILE*,
 	{
 		while (file->matches->enumerate(file->matches, &name, NULL))
 		{
+			char fname[PATH_MAX] = { 0 };
+			memcpy(fname, name, strlen(name));
+
+#ifdef _WIN32
+			int len = 0;
+			if (get_install_dir(fname))
+			{
+				len = strlen(fname);
+				if(strstr(name, "/etc/strongswan.conf") != NULL)
+				{
+					strcpy((&fname[len]), name);
+				}
+				else
+				{
+					memset(fname, 0, PATH_MAX);
+					memcpy(fname, name, strlen(name));
+				}
+			}
+			else
+			{
+				memset(fname, 0, PATH_MAX);
+				memcpy(fname, name, strlen(name));
+			}
+			for (int i = 0; i < strlen(fname); i++)
+			{
+				if(fname[i] == '/')
+				{
+					fname[i] = '\\';
+				}
+			}
+#endif
 			INIT(next,
-				.name = strdup(name),
-				.file = fopen(name, "r"),
+				.name = strdup(fname),
+				.file = fopen(fname, "r"),
 			);
-
 			if (next->file && fstat(fileno(next->file), &st) == 0 &&
 				S_ISREG(st.st_mode))
 			{
 				array_insert(this->files, ARRAY_TAIL, next);
 				return next->file;
 			}
-			PARSER_DBG2(&this->public, "unable to open '%s'", name);
+			PARSER_DBG2(&this->public, "unable to open '%s'", fname);
 			parser_helper_file_destroy(next);
 		}
 		file->matches->destroy(file->matches);
@@ -168,6 +259,21 @@ METHOD(parser_helper_t, file_include, void,
 		free(dir);
 	}
 
+#ifdef _WIN32
+	if(strstr(pat, "/etc/strongswan.conf") != NULL)
+	{
+		char fname[PATH_MAX] = { 0 };
+		int len = 0;
+		memcpy(fname, pat, strlen(pat));
+		if (get_install_dir(fname))
+		{
+			len = strlen(fname);
+			strcpy((&fname[len]), pat);
+			memset(pat, 0, sizeof(pat));
+			memcpy(pat, fname, strlen(fname));
+		}		
+	}
+#endif
 	file->matches = enumerator_create_glob(pat);
 	if (!file->matches)
 	{	/* if glob(3) is not available, try to load pattern directly */
diff --git a/src/libstrongswan/utils/utils.h b/src/libstrongswan/utils/utils.h
index c7ccd3afa..1b9d18570 100644
--- a/src/libstrongswan/utils/utils.h
+++ b/src/libstrongswan/utils/utils.h
@@ -15,6 +15,28 @@
  * for more details.
  */
 
+/*
+ * Copyright (C) 2019-2022 Marvell 
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a copy
+ * of this software and associated documentation files (the "Software"), to deal
+ * in the Software without restriction, including without limitation the rights
+ * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the Software is
+ * furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+ * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+ * THE SOFTWARE.
+ */
+
 /**
  * @defgroup utils_i utils
  * @{ @ingroup utils
@@ -38,6 +60,8 @@
 
 #ifdef WIN32
 # include "compat/windows.h"
+#define WIN32_LEAN_AND_MEAN
+#include <windows.h>
 #else
 # include <arpa/inet.h>
 # include <sys/socket.h>
@@ -48,6 +72,11 @@
 # include <signal.h>
 #endif
 
+#ifdef WIN32
+#define AF_NETLINK	16
+#define PF_NETLINK	AF_NETLINK
+#endif
+
 #include "utils/types.h"
 #include "enum.h"
 #include "utils/atomics.h"
diff --git a/src/swanctl/swanctl.c b/src/swanctl/swanctl.c
index a3bbc28fd..d43336921 100644
--- a/src/swanctl/swanctl.c
+++ b/src/swanctl/swanctl.c
@@ -15,9 +15,32 @@
  * for more details.
  */
 
+/*
+ * Copyright (C) 2019-2022 Marvell 
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a copy
+ * of this software and associated documentation files (the "Software"), to deal
+ * in the Software without restriction, including without limitation the rights
+ * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the Software is
+ * furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+ * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+ * THE SOFTWARE.
+ */
+
 #include "swanctl.h"
 #include "command.h"
 
+#include <stdlib.h>
 #include <unistd.h>
 
 #include <library.h>
@@ -28,6 +51,43 @@
  */
 char *swanctl_dir;
 
+#ifdef _WIN32
+static bool get_install_dir(char *install_dir)
+{
+	char path[PATH_MAX], *pos;
+	HMODULE module;
+
+	module = GetModuleHandle(NULL);
+	if (!module)
+	{
+		return FALSE;
+	}
+	if (!GetModuleFileName(module, path, sizeof(path)))
+	{
+		return FALSE;
+	}
+
+	pos = strrchr(path, '\\');
+	if (!pos)
+	{
+		return FALSE;
+	}
+	*pos = 0;
+
+	pos = strstr(path, "\\usr\\");
+	if (!pos)
+	{
+		return FALSE;
+	}
+	*pos = 0;
+
+	memset(install_dir, 0, sizeof(install_dir));
+	strcpy(install_dir, path);
+
+	return TRUE;
+}
+#endif
+
 /*
  * Described in header
  */
@@ -35,6 +95,7 @@ settings_t *load_swanctl_conf(char *file)
 {
 	settings_t *cfg;
 	char buf[PATH_MAX];
+	char fname[PATH_MAX] = { 0 };
 
 	if (!file)
 	{
@@ -48,6 +109,39 @@ settings_t *load_swanctl_conf(char *file)
 				 DIRECTORY_SEPARATOR, SWANCTL_CONF);
 	}
 
+	memcpy(fname, file, strlen(file));
+#ifdef _WIN32
+	int len = 0;
+	if (get_install_dir(fname))
+	{
+		len = strlen(fname);
+		if(strstr(file, "/etc/swanctl\\swanctl.conf") != NULL)
+		{
+			strcpy((&fname[len]), file);
+		}
+		else
+		{
+			memset(fname, 0, PATH_MAX);
+			memcpy(fname, file, strlen(file));
+		}
+	}
+	else
+	{
+		memset(fname, 0, PATH_MAX);
+		memcpy(fname, file, strlen(file));
+	}
+	for (int i = 0; i < strlen(fname); i++)
+	{
+		if(fname[i] == '/')
+		{
+			fname[i] = '\\';
+		}
+	}
+	memset(file, 0, PATH_MAX);
+	memcpy(file, fname, strlen(fname));
+#endif
+	//DBG1(DBG_CFG, "STAGING swanctl - load_swanctl_conf - file=%s", file);
+
 	cfg = settings_create(file);
 	if (!cfg)
 	{
-- 
2.31.1.windows.1

